diff --git a/src/server.c b/src/server.c
index 1fd29046e8..714d0c5171 100644
--- a/src/server.c
+++ b/src/server.c
@@ -3252,6 +3252,7 @@ void apply_server_state(void)
 			/* free up memory in case of error during the processing of the line */
 			free(line);
 		}
+		fclose(f);
 	}
  out_load_server_state_in_tree:
 
@@ -3347,6 +3348,8 @@ void apply_server_state(void)
 					goto next;
 
 				st = container_of(node, struct state_line, name_name);
+				if (strlen(st->line) > SRV_STATE_LINE_MAXLEN)
+					goto next;
 				memcpy(mybuf, st->line, strlen(st->line));
 				mybuf[strlen(st->line)] = 0;
 
@@ -3362,7 +3365,7 @@ void apply_server_state(void)
 
 			continue; /* next proxy in list */
 		}
-		else {
+		else if (filepath) {
 			/* load 'local' state file */
 			errno = 0;
 			f = fopen(filepath, "r");
@@ -3434,9 +3437,9 @@ void apply_server_state(void)
 				/* now we can proceed with server's state update */
 				srv_update_state(srv, version, srv_params);
 			}
+			fileclose:
+				fclose(f);
 		}
-fileclose:
-		fclose(f);
 	}
 
 	/* now free memory allocated for the tree */
